(function ($) {

Drupal.samlSp = Drupal.samlSp || {};

Drupal.samlSp.idpMetadataParse = function() {
  var xml = $.parseXML($('textarea[name="idp_metadata"]').val().trim());
  Drupal.samlSp.idpMetadataXML = $(xml);
  $('input#edit-idp-entity-id').val(Drupal.samlSp.idpMetadataXML.find('EntityDescriptor').attr('entityID').trim());
  // the certificate for signing needs to have whitespace trimmed and the new lines removed
  $('textarea#edit-idp-x509-cert').text($(Drupal.samlSp.idpMetadataXML.find('X509Certificate')[0]).text().trim().replace(/\n/g, '').replace(/\s/g, ''));

  $(Drupal.samlSp.idpMetadataXML.find('SingleSignOnService')).each(function() {
    if ($(this).attr('Binding') === 'urn:oasis:names:tc:SAML:2.0:bindings:HTTP-Redirect' ) {
      $('input#edit-idp-login-url').val($(this).attr('Location').trim());
    }
  });

  $(Drupal.samlSp.idpMetadataXML.find('SingleLogoutService')).each(function() {
    if ($(this).attr('Binding') === 'urn:oasis:names:tc:SAML:2.0:bindings:HTTP-Redirect' ) {
      $('input#edit-idp-logout-url').val($(this).attr('Location').trim());
    }
  });
};


Drupal.behaviors.samlSpIdpForm = {
  'attach': function() {
    $('textarea[name="idp_metadata"]:not(.idp-form-processed)')
      .addClass('idp-form-processed')
      .keyup(function() {
        Drupal.samlSp.idpMetadataParse();
      })
      .mouseup(function() {
        Drupal.samlSp.idpMetadataParse();
      });
  },
};

})(jQuery);
